diff --git a/examples/scriptableapplication/mainwindow.cpp b/examples/scriptableapplication/mainwindow.cpp
index e754bcb..ad43654 100644
--- a/examples/scriptableapplication/mainwindow.cpp
+++ b/examples/scriptableapplication/mainwindow.cpp
@@ -50,6 +50,7 @@
 
 #include "mainwindow.h"
 #include "pythonutils.h"
+#include "sbkpython.h"
 
 #include <QtWidgets/QAction>
 #include <QtWidgets/QApplication>
@@ -139,3 +140,18 @@ void MainWindow::testFunction1()
     qDebug().noquote() << message;
     statusBar()->showMessage(message);
 }
+
+QVariant MainWindow::myFunc()
+{
+    QVariant var;
+    var.setValue(nullptr);
+    qDebug() << "MainWindow::myFunc(): var=" << var << "varType=" << var.type()
+             << "isValid" << var.isValid()
+             <<  "\nPy_REFCNT(Py_None)=" << Py_REFCNT(Py_None);
+
+    QVariantList list;
+	for (int i=0; i<10; ++i) {
+        list.append(var);
+    }
+    return list;
+}
diff --git a/examples/scriptableapplication/mainwindow.h b/examples/scriptableapplication/mainwindow.h
index 4dcafc7..a74d1c5 100644
--- a/examples/scriptableapplication/mainwindow.h
+++ b/examples/scriptableapplication/mainwindow.h
@@ -62,6 +62,7 @@ public:
     MainWindow();
 
     void testFunction1();
+    QVariant myFunc();
 
 private Q_SLOTS:
     void slotRunScript();
diff --git a/examples/scriptableapplication/pyside2.pri b/examples/scriptableapplication/pyside2.pri
index bd0eeef..d44615e 100644
--- a/examples/scriptableapplication/pyside2.pri
+++ b/examples/scriptableapplication/pyside2.pri
@@ -4,10 +4,10 @@ PYTHON_LFLAGS = $$system(python $$PWD/pyside2_config.py --python-link)
 
 PYSIDE2 = $$system(python $$PWD/pyside2_config.py --pyside2)
 isEmpty(PYSIDE2): error(Unable to locate PySide2)
-PYSIDE2_INCLUDE = $$system(python $$PWD/pyside2_config.py --pyside2-include)
+PYSIDE2_INCLUDE = /usr/include/PySide2/ #$$system(python $$PWD/pyside2_config.py --pyside2-include)
 PYSIDE2_LFLAGS = $$system(python $$PWD/pyside2_config.py --pyside2-link)
-PYSIDE2_SHARED_LIBRARIES = $$system(python $$PWD/pyside2_config.py --pyside2-shared-libraries)
-CLANG_BIN_DIR = $$system(python $$PWD/pyside2_config.py --clang-bin-dir)
+PYSIDE2_SHARED_LIBRARIES = /usr/lib64/python3.9/site-packages/PySide2#$$system(python $$PWD/pyside2_config.py --pyside2-shared-libraries)
+CLANG_BIN_DIR = /usr/bin #$$system(python $$PWD/pyside2_config.py --clang-bin-dir)
 
 INCLUDEPATH += $$PYTHON_INCLUDE $$PYSIDE2_INCLUDE
 LIBS += $$PYTHON_LFLAGS $$PYSIDE2_LFLAGS
diff --git a/examples/scriptableapplication/pythonutils.cpp b/examples/scriptableapplication/pythonutils.cpp
index 27f1bc7..28ca309 100644
--- a/examples/scriptableapplication/pythonutils.cpp
+++ b/examples/scriptableapplication/pythonutils.cpp
@@ -122,7 +122,7 @@ bool bindAppObject(const QString &moduleName, const QString &name,
         return false;
     PyTypeObject *typeObject = SbkAppLibTypes[index];
 
-    PyObject *po = Shiboken::Conversions::pointerToPython(reinterpret_cast<const SbkObjectType *>(typeObject), o);
+	PyObject *po = Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(typeObject), o);
     if (!po) {
         qWarning() << __FUNCTION__ << "Failed to create wrapper for" << o;
         return false;
diff --git a/examples/scriptableapplication/scriptableapplication.pro b/examples/scriptableapplication/scriptableapplication.pro
index ae98dd5..1ce6b26 100644
--- a/examples/scriptableapplication/scriptableapplication.pro
+++ b/examples/scriptableapplication/scriptableapplication.pro
@@ -14,13 +14,13 @@ QT_INCLUDEPATHS = -I$$[QT_INSTALL_HEADERS] -I$$[QT_INSTALL_HEADERS]/QtCore \
 
 SHIBOKEN_OPTIONS = --generator-set=shiboken --enable-parent-ctor-heuristic \
     --enable-pyside-extensions --enable-return-value-heuristic --use-isnull-as-nb_nonzero \
-    $$QT_INCLUDEPATHS -I$$PWD -T$$PWD -T$$PYSIDE2/typesystems --output-directory=$$OUT_PWD
+	$$QT_INCLUDEPATHS -I$$PWD -T$$PWD -T/usr/share/PySide2/typesystems/ --output-directory=$$OUT_PWD
 
 # MSVC does not honor #define protected public...
 win32:SHIBOKEN_OPTIONS += --avoid-protected-hack
 
 # Prepare the shiboken tool
-QT_TOOL.shiboken.binary = $$system_path($$PYSIDE2/shiboken2)
+QT_TOOL.shiboken.binary = /usr/bin/shiboken2 # $$system_path($$PYSIDE2/shiboken2)
 win32 {
     # Add the libclang/bin subdir to PATH.
     CLANG_PATH.name = PATH
@@ -31,6 +31,7 @@ win32 {
 qtPrepareTool(SHIBOKEN, shiboken)
 QT_TOOL_ENV =
 
+#message("QMAKE_FILE_IN: $$QMAKE_FILE_IN")
 # Shiboken run that adds the module wrapper to GENERATED_SOURCES
 shiboken.output = $$WRAPPER_DIR/applib_module_wrapper.cpp
 shiboken.commands = $$SHIBOKEN $$SHIBOKEN_OPTIONS $$PWD/wrappedclasses.h ${QMAKE_FILE_IN}
@@ -74,12 +75,16 @@ win32:QMAKE_EXTRA_COMPILERS += hard_link_libraries
 
 INCLUDEPATH += $$WRAPPER_DIR
 
+INCLUDEPATH += /usr/include/shiboken2/
+
 # fixme: Hack to find wrappers
-PACKAGE_DIR = $$PWD/../../../../pyside_package/PySide2
+PACKAGE_DIR = /usr #/usr/lib64/python3.9/site-packages/PySide2
 
 INCLUDEPATH += $$PACKAGE_DIR/include/PySide2/QtWidgets \
     $$PACKAGE_DIR/include/PySide2/QtGui $$PACKAGE_DIR/include/PySide2/QtCore
 
+LIBS += -L/usr/lib64/ -l:libshiboken2.cpython-39-x86_64-linux-gnu.so -l:libpyside2.cpython-39-x86_64-linux-gnu.so
+
 SOURCES += \
     main.cpp \
     mainwindow.cpp \