diff --git a/src/charts/axis/cartesianchartaxis.cpp b/src/charts/axis/cartesianchartaxis.cpp
index 30263754..8e6929e3 100644
--- a/src/charts/axis/cartesianchartaxis.cpp
+++ b/src/charts/axis/cartesianchartaxis.cpp
@@ -158,12 +158,17 @@ void CartesianChartAxis::updateMinorTickItems()
 
         expectedCount = minorTickCount * (logValueAxis->tickCount() + 1);
         expectedCount = qMax(expectedCount, logValueAxis->minorTickCount());
+        qDebug() << __FUNCTION__ << "minorTickCount=" << minorTickCount
+                 << "expectedCount=" << expectedCount;
+
     } else {
         // minor ticks are not supported
         return;
     }
 
     int diff = expectedCount - currentCount;
+    qDebug() << __FUNCTION__ << "diff=" << diff;
+
     if (diff > 0) {
         for (int i = 0; i < diff; ++i) {
             QGraphicsLineItem *minorGridLineItem = new QGraphicsLineItem(this);
diff --git a/src/charts/axis/chartaxiselement.cpp b/src/charts/axis/chartaxiselement.cpp
index 1723ba29..a93193a3 100644
--- a/src/charts/axis/chartaxiselement.cpp
+++ b/src/charts/axis/chartaxiselement.cpp
@@ -535,10 +535,15 @@ QStringList ChartAxisElement::createValueLabels(qreal min, qreal max, int ticks,
 QStringList ChartAxisElement::createLogValueLabels(qreal min, qreal max, qreal base, int ticks,
                                                    const QString &format) const
 {
+    qDebug() << __FUNCTION__ << "rg=" <<  min << max << "base=" << base
+              << "ticks=" << ticks;
+
     QStringList labels;
 
-    if (max <= min || ticks < 1)
+    if (max <= min || ticks < 1) {
+        qDebug() << __FUNCTION__ <<"BAILOUT";
         return labels;
+    }
 
     const int firstTick = qCeil(qLn(base > 1 ? min : max) / qLn(base));
     if (format.isEmpty()) {
@@ -573,6 +578,8 @@ QStringList ChartAxisElement::createLogValueLabels(qreal min, qreal max, qreal b
         }
     }
 
+    qDebug() << __FUNCTION__ << labels;
+
     return labels;
 }
 
diff --git a/src/charts/axis/verticalaxis.cpp b/src/charts/axis/verticalaxis.cpp
index 6ca65c07..e2279f92 100644
--- a/src/charts/axis/verticalaxis.cpp
+++ b/src/charts/axis/verticalaxis.cpp
@@ -49,6 +49,7 @@ QSizeF VerticalAxis::sizeHint(Qt::SizeHint which, const QSizeF &constraint) cons
 
 void VerticalAxis::updateGeometry()
 {
+    qDebug() << __FUNCTION__ ;
     const QList<qreal> &layout = ChartAxisElement::layout();
     const QList<qreal> &dynamicMinorTicklayout = ChartAxisElement::dynamicMinorTicklayout();
 
@@ -131,6 +132,7 @@ void VerticalAxis::updateGeometry()
     bool labelsTruncated = false;
 
     for (int i = 0; i < layout.size(); ++i) {
+        qDebug() << __FUNCTION__ << '#' << i << '/' << layout.size();
         //items
         QGraphicsLineItem *gridItem = static_cast<QGraphicsLineItem *>(lines.at(i));
         QGraphicsLineItem *tickItem = static_cast<QGraphicsLineItem *>(arrow.at(i + 1));
@@ -179,6 +181,7 @@ void VerticalAxis::updateGeometry()
         //label transformation origin point
         const QRectF &rect = labelItem->boundingRect();
         QPointF center = rect.center();
+        qDebug() << __FUNCTION__ << '#' << i << "center=" << center;
         labelItem->setTransformOriginPoint(center.x(), center.y());
         qreal widthDiff = rect.width() - boundingRect.width();
         qreal heightDiff = rect.height() - boundingRect.height();
@@ -294,6 +297,7 @@ void VerticalAxis::updateGeometry()
 
         // Round to full pixel via QPoint to avoid one pixel clipping on the edge in some cases
         labelItem->setPos(labelPos.toPoint());
+        qDebug() << __FUNCTION__ << '#' << i << labelItem->toPlainText() << labelItem->pos();
 
         //label overlap detection - compensate one pixel for rounding errors
         if (axis()->isReverse()) {
@@ -414,6 +418,7 @@ void VerticalAxis::updateMinorTickGeometry()
         minorTickCount = logValueAxis->minorTickCount();
         if (minorTickCount < 0)
             minorTickCount = qMax(qFloor(base) - 2, 0);
+        qDebug() << __FUNCTION__ << "minorTickCount=" << minorTickCount;
 
         // Two "virtual" ticks are required to make sure that all minor ticks
         // are displayed properly (even for the partially visible segments of
@@ -425,6 +430,7 @@ void VerticalAxis::updateMinorTickGeometry()
             tickSpacing = layout.at(0) - layout.at(1);
             layout.prepend(layout.at(0) + tickSpacing);
             layout.append(layout.at(layout.size() - 1) - tickSpacing);
+            qDebug() << __FUNCTION__ << "layout.size() >= 2";
         } else {
             const qreal logMax = qLn(logValueAxis->max()) / logBase;
             const qreal logMin = qLn(logValueAxis->min()) / logBase;
@@ -434,6 +440,10 @@ void VerticalAxis::updateMinorTickGeometry()
             const qreal delta = gridGeometry().height() / qAbs(logMax - logMin);
             const qreal extraMaxTick = edge - (logExtraMaxTick - qMin(logMin, logMax)) * delta;
             const qreal extraMinTick = edge - (logExtraMinTick - qMin(logMin, logMax)) * delta;
+            qDebug() << __FUNCTION__ << "rg=" << logMin << logMax
+                     << "logExtraMinTick=" << logExtraMinTick << "logExtraMaxTick=" << logExtraMaxTick
+                     << "edge=" << edge << "delta=" << delta
+                     << "extraMinTick=" << extraMinTick << "extraMaxTick=" << extraMaxTick;
 
             // Calculate tickSpacing using one (if layout.size() == 1) or two
             // (if layout.size() == 0) "virtual" ticks. In both cases animation
@@ -441,12 +451,14 @@ void VerticalAxis::updateMinorTickGeometry()
             layout.prepend(extraMinTick);
             layout.append(extraMaxTick);
             tickSpacing = layout.at(0) - layout.at(1);
+            qDebug() << __FUNCTION__ << "tickSpacing=" << tickSpacing;
         }
 
         const qreal minorTickStepValue = qFabs(base - 1.0) / qreal(minorTickCount + 1);
         for (int i = 0; i < minorTickCount; ++i) {
             const qreal x = minorTickStepValue * qreal(i + 1) + 1.0;
             const qreal minorTickSpacing = tickSpacing * (qLn(x) / logBase);
+            qDebug() << __FUNCTION__ << "mt=" << i << "x=" << x << "minorTickSpacing=" << minorTickSpacing;
             minorTickSpacings.append(minorTickSpacing);
         }
         break;
@@ -457,9 +469,15 @@ void VerticalAxis::updateMinorTickGeometry()
     }
 
     const QValueAxis *valueAxis = qobject_cast<QValueAxis *>(axis());
+    qDebug() << __FUNCTION__ << "minorTickSpacings=" << minorTickSpacings;
+    if (valueAxis)
+        qDebug() << "tickType=" << valueAxis->tickType() << valueAxis->alignment();
     if (valueAxis && valueAxis->tickType() == QValueAxis::TicksDynamic) {
         const QList<qreal> dynamicMinorTicklayout = ChartAxisElement::dynamicMinorTicklayout();
         const QRectF &gridRect = gridGeometry();
+        if (valueAxis)
+            qDebug() << "gridGeometry=" << gridRect;
+
         const qreal deltaY = gridRect.height() / (valueAxis->max() - valueAxis->min());
         const qreal bottomPos = gridRect.bottom();
         const qreal topPos = gridRect.top();
@@ -494,6 +512,7 @@ void VerticalAxis::updateMinorTickGeometry()
                 minorArrowLineItemX2 = 0.0;
                 break;
             }
+             qDebug() << "      " << i << "minorGridLineItemY=" << minorGridLineItemY;
 
             minorGridLineItem->setLine(gridGeometry().left(), minorGridLineItemY,
                                        gridGeometry().right(), minorGridLineItemY);